# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from axis_msgs/Ptz.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class Ptz(genpy.Message):
  _md5sum = "eef4827ef5b8ba89a8c9fa0810a30294"
  _type = "axis_msgs/Ptz"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# The pan position or velocity of the camera, in radians or rad/s
# 0.0 is forward / stopped
# + is to the left (anticlockwise)
# - is to the right (clockwise)
# Valid ranges:
#  position: -pi to pi
#  speed: -2.61 to +2.61 (max 150 deg/s)
float32 pan

# The tilt position or velocity of the camera, in radians or rad/s
# 0.0 is parallel with the camera's base / stopped
# + is upward
# - is downward
# Valid ranges:
#  position: -pi/2 to pi/2
#  speed: -2.61 to +2.61 (max 150 deg/s)
float32 tilt

# The camera's zoom level or speed
# The allowed range varies depending on whether we're using position or velocity control
# Valid ranges:
#  position: 0 to 9999
#  speed: -100 to 100
float32 zoom
"""
  __slots__ = ['pan','tilt','zoom']
  _slot_types = ['float32','float32','float32']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       pan,tilt,zoom

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(Ptz, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.pan is None:
        self.pan = 0.
      if self.tilt is None:
        self.tilt = 0.
      if self.zoom is None:
        self.zoom = 0.
    else:
      self.pan = 0.
      self.tilt = 0.
      self.zoom = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3f().pack(_x.pan, _x.tilt, _x.zoom))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 12
      (_x.pan, _x.tilt, _x.zoom,) = _get_struct_3f().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3f().pack(_x.pan, _x.tilt, _x.zoom))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 12
      (_x.pan, _x.tilt, _x.zoom,) = _get_struct_3f().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3f = None
def _get_struct_3f():
    global _struct_3f
    if _struct_3f is None:
        _struct_3f = struct.Struct("<3f")
    return _struct_3f
